#include <fstream>
#include <iostream>
#define MAXSIZE 10000

using namespace std;
int core(int, int, int, int, std::istream*, std::ostream*);

int main()
{
   int i;
	unsigned char treshold='0',xheader[54];
	char xc;
	string  in_file, out_file;
	unsigned long offset,width,owidth,height,size;


	cout << "Feldolgozando kep neve? ";
	getline(cin, in_file);
	
	cout << "Eredmenyek kiirasa a kovetkezo fajlba: ";
	getline(cin, out_file);

	cout << "Kuszobertek? ";
	cin >> i;
	
	treshold=(unsigned char)i;

	ofstream dat(out_file.c_str());

	dat << "# Kuszob: " << (int) treshold << endl;

	ifstream bmp(in_file.c_str(),ios::in|ios::binary);
   for (i=0;i<54;i++) { bmp.get(xc); xheader[i]=(unsigned char) xc;}

	if ((xheader[1]*256+xheader[0])!=19778) 
	{
		cout << "A file nem Windows Bitmap File formatumu!";
	   exit(1);
	}
	offset=xheader[11]*256+xheader[10];
	width=owidth=(long)16777216*xheader[21]+(long)65536*xheader[20]+(long)256*xheader[19]+xheader[18];
   height=(long)16777216*xheader[25]+(long)65536*xheader[24]+(long)256*xheader[23]+xheader[22];
	size=(long)16777216*xheader[37]+(long)65536*xheader[36]+(long)256*xheader[35]+xheader[34];
	dat << "# Kepmeret: " << owidth << " x " << height; 
	if (size!=owidth*height)
	{
		dat << " <> " << size << ", nem egyezik a szorzat." << endl;
		width=size/height;
		if (size!=width*height) 
		{
			dat << "# Javitas sikertelen!" << endl;
			cout << "Hibas a fejlecben a meret leirasa! Javitas sem sikerult." << endl; 
			exit(2);
		}
		else
		{
			dat << "# Kepmeret javitva: "  << width << " x " << height;
		}
	}
	dat << " = " << size << endl;
	
	dat << "# Eltolas: " << offset << endl;
   for (i=54;i<offset;i++) { bmp.get(xc); }

	i=core(width,owidth,height,treshold,&bmp,&dat);

	return i;
}

int core(int wi,int ow,int he,int tr,istream *bmp,ostream *dat)
{
	int i,j,k;
	char xc;
	int row[MAXSIZE];
	int max=0,areas[MAXSIZE];
	
	for (i=0;i<ow+1;i++) row[i]=0;
	areas[0]=0;
	
	for (i=1;i<=he;i++)
	{
		for(j=1;j<=wi;j++)
		{
			bmp->get(xc);
//			cout << i << " " << j << " " << (int) xc << " " << row[j] << endl;
			if (j<ow+1)
			{
				if ((unsigned char) xc>tr)
				{
					row[j]=0;
					areas[0]++;
				}
				else
				{
					if (row[j]==0)
					{
						if ((j==1) || (row[j-1]==0))
						{
							max++;
							row[j]=max;
							areas[max]=1;
						}
						else
						{
							row[j]=row[j-1];
							areas[row[j]]++;
						}
					}
					else
					{
						if ((j==1) || (row[j-1]==0))
						{
							areas[row[j]]++;
						}
						else
						{
							if (row[j]!=row[j-1])
							{
								areas[row[j]]+=areas[max];
								areas[max]=0;
								for (k=j;k>-1;k--)
								{
									if (row[k]==max) { row[k]=row[j]; }
									else
									if ((row[k]>0)&&(row[k]<row[j])) { break;}
								}
								max--;
							}
							areas[row[j]]++;
						}
					}
				}
			}
//			cout << " max = " << max;
		}
	}
			*dat << "# Hatterben levo pontok szama: " << areas[0] << endl;
			for (k=1;k<=max;k++){ *dat << areas[k] << endl; }
return 0;
}
